;;DDON commands
;
;
;   DDON - Changes OFF layers to ON by Dialog
;
;
;   Written by :    Mark W. Kiker - caddmanager.com
;   Date:           2004
;
;   USE AT YOUR OWN RISK...
;
;
;     Permission to use, copy, modify, and distribute this software 
;     for any purpose and without fee is hereby granted, provided 
;     that the above copyright notice appears in all copies and that 
;     both that copyright notice and this permission notice appear in 
;     all supporting documentation.
;
;     THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED
;     WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
;     PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
;     ****************************************************************

;;;
;;; Error Function
;;;
(defun *cng_err* (msg)
   (if (/= msg "Function cancelled")
      (if (= msg "quit / exit abort")   
         (princ)
         (princ (strcat "\nError: " msg))
      )
   )
   (setq *error* *err_old* *err_old* nil)
   (princ)
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; DDON sets layers that are OFF to ON
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:DDON ( / dcl_id llist lname)
   (setq *err_old* *error* *error* *cng_err*)
   (setq tbllist (tblnext "layer" T)
         laylist nil)
   (while tbllist
   (setq llist (cdr (assoc 2 tbllist)))
   (setq cn (cdr (assoc 62 tbllist)))
    (if (> 0 cn)
        (setq laylist (cons llist laylist))
    )
    (setq tbllist (tblnext "layer"))
   )
   (if laylist
   (progn
   (setq laylist (acad_strlsort laylist))
   (setq dcl_id (load_dialog "ddon.dcl"))
   (if
    (not (new_dialog "DDON" dcl_id))
    (exit)
   )
   (start_list "layerbox")
   (mapcar 'add_list laylist)
   (end_list)

   (setq return_list nil)

   (action_tile "layerbox" "(setq return_list (make_return_list $value))")
   (action_tile "cancel" "(exit)")
   
   (if
    (= 1 (start_dialog))
    (progn
    (setq lyrs "")
    (foreach lname return_list
     (setq lyrs (strcat lname "," lyrs))
    )
    (command "layer" "on" lyrs "")
    )
   )
   (unload_dialog dcl_id)
   )
   (alert "No layers are OFF")
   )
   (setq *error* *err_old* *err_old* nil)
   (prin1)
)



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Make a list of the layers selected ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun make_return_list (list_box_value / item return_list)
  (setq count 1)
  (while
    (setq item (read list_box_value))
    (setq return_list (cons (nth item laylist) return_list))
    (while
      (and
        (/= " " (substr list_box_value count 1))
        (/= ""  (substr list_box_value count 1))
      )
      (setq count (1+ count))
    )
    (setq list_box_value (substr list_box_value count))
  )
  (reverse return_list)
)

;;;====================================;;;
;;; Make a list of the layers selected ;;;
;;;====================================;;;

(defun make_return_list2 (list_box_value / item return_list)
  (setq count 1)
  (while
    (setq item (read list_box_value))
    (setq return_list (cons (nth item lnlist) return_list))
    (while
      (and
        (/= " " (substr list_box_value count 1))
        (/= ""  (substr list_box_value count 1))
      )
      (setq count (1+ count))
    )
    (setq list_box_value (substr list_box_value count))
  )
  (reverse return_list)
)

;(prompt "DDON Loaded.")
(princ)
